; Begin
	R0L EQU 0x20
	R0H EQU 0x21
	R1L EQU 0x22
	R1H EQU 0x23
	R2L EQU 0x24
	R2H EQU 0x25
	R3L EQU 0x26
	R3H EQU 0x27
	R4L EQU 0x28
	R4H EQU 0x29
	R5L EQU 0x2A
	R5H EQU 0x2B
	W_TEMP EQU 0x7F
	STATUS_TEMP EQU 0x7E
	R0L_TEMP EQU 0x2C
	R0H_TEMP EQU 0x2D
	R1L_TEMP EQU 0x2E
	R1H_TEMP EQU 0x2F
	R2L_TEMP EQU 0x30
	R2H_TEMP EQU 0x31
	R3L_TEMP EQU 0x32
	R3H_TEMP EQU 0x33
	R4L_TEMP EQU 0x34
	R4H_TEMP EQU 0x35
	R5L_TEMP EQU 0x36
	R5H_TEMP EQU 0x37
	FSR_TEMP EQU 0x38
	ORG 0x0000
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0005
	ORG 0x0004
	MOVWF W_TEMP
	SWAPF STATUS,W
	CLRF STATUS
	MOVWF STATUS_TEMP
	CALL L0006
	SWAPF STATUS_TEMP,W
	MOVWF STATUS
	SWAPF W_TEMP,F
	SWAPF W_TEMP,W
	RETFIE
L0005:
; 1:  'PROGRAM TO CHARGE LEAD ACID BATTERIES WITH SOLAR PANEL
; 2:  'USES PIC 16F877 AT 4 MHZ
; 3:  'AUTHOR SANTHOSH JAYARAJAN
; 4: 
; 5:  'NOTES:
; 6: 
; 7: 
; 8: 
; 9:  '*********************************************
; 10:  'RA2=SOLAR CELL VOLTAGE
; 11:  'RA1=BATTERY CHARGE CURRENT IB
; 12: 
; 13:  'RB0-RB7:LCD DATA LINES
; 14: 
; 15:  'RC0=PWM OUTPUT FOR CHARGER
; 16: 
; 17:  'RD1:LCD R/S
; 18:  'RD2:LCD R/W
; 19:  'RD3:LCD-E
; 20:  'RD4:SPARE
; 21:  'RD6:SPARE
; 22: 
; 23:  'VARIABLE DECLARATION FOR LCD MODULE
; 24: Define LCD_BITS = 8
; 25: Define LCD_DREG = PORTB
; 26: Define LCD_DBIT = 0
; 27: Define LCD_RSREG = PORTD
; 28: Define LCD_RSBIT = 1
; 29: Define LCD_EREG = PORTD
; 30: Define LCD_EBIT = 3
; 31: Define LCD_RWREG = PORTD
; 32: Define LCD_RWBIT = 2
; 33: Define ADC_SAMPLEUS = 100
; 34: Define LCD_LINES = 2
; 35: Define LCD_CHARS = 16
; 36: 
; 37:  'for simulation only
; 38: Define LCD_COMMANDUS = 5000 'delay after LCDCMDOUT, default value is 5000
; 39: Define LCD_DATAUS = 100 'delay after LCDOUT, default value is 100
; 40: Define LCD_INITMS = 20
; 41: 
; 42:  'SETTING THE TRISA,TRISB AND ADCON1 REGISTERS
; 43:  'ALL A PINS ARE INPUTS AND 3 E PORTS AS INPUTS
; 44: 
; 45: TRISA = %00110111
	BSF STATUS,RP0
	MOVLW 0x37
	MOVWF 0x05
	BCF STATUS,RP0
; 46: ADCON1 = %00000000
	BSF STATUS,RP0
	CLRF 0x1F
	BCF STATUS,RP0
; 47: TRISE = %00000111
	BSF STATUS,RP0
	MOVLW 0x07
	MOVWF 0x09
	BCF STATUS,RP0
; 48: ADCON0 = 0x80
	MOVLW 0x80
	MOVWF 0x1F
; 49: TRISD = %11000000
	BSF STATUS,RP0
	MOVLW 0xC0
	MOVWF 0x08
	BCF STATUS,RP0
; 50: TRISB = %00000000
	BSF STATUS,RP0
	CLRF 0x06
	BCF STATUS,RP0
; 51: INTCON = %10100000
	MOVLW 0xA0
	MOVWF 0x0B
; 52: OPTION_REG = %00000111
	BSF STATUS,RP0
	MOVLW 0x07
	MOVWF 0x01
	BCF STATUS,RP0
; 53: 
; 54:  'VARIABLE DECLARTION
; 55:  'FOR BATTERY VOLTAGE MEASUREMENT
; 56: Dim batt_curr As Word
;       The address of 'batt_curr' is 0x3A
	batt_curr EQU 0x3A
; 57: Dim batt_curr_count As Byte
;       The address of 'batt_curr_count' is 0x3C
	batt_curr_count EQU 0x3C
; 58: Symbol chg_on = PORTA.3
;       The address of 'chg_on' is 0x5,3
; 59: Dim boost_on As Bit
;       The address of 'boost_on' is 0x39,0
; 60: Dim trickle_on As Bit
;       The address of 'trickle_on' is 0x39,1
; 61: Dim was_boost As Bit
;       The address of 'was_boost' is 0x39,2
; 62: Dim was_trickle As Bit
;       The address of 'was_trickle' is 0x39,3
; 63: Dim trickle_time_count As Word
;       The address of 'trickle_time_count' is 0x3D
	trickle_time_count EQU 0x3D
; 64: 
; 65:  'FOR BATTERY and SOLAR VOLTAGE
; 66: Dim batt_volt_raw As Word
;       The address of 'batt_volt_raw' is 0x3F
	batt_volt_raw EQU 0x3F
; 67: Dim batt_volt As Word
;       The address of 'batt_volt' is 0x41
	batt_volt EQU 0x41
; 68: Dim solar_volt_raw As Word
;       The address of 'solar_volt_raw' is 0x43
	solar_volt_raw EQU 0x43
; 69: Dim solar_volt As Word
;       The address of 'solar_volt' is 0x45
	solar_volt EQU 0x45
; 70: 
; 71:  'FOR BATTERY CURRENT
; 72: Dim batt_curr_raw As Word
;       The address of 'batt_curr_raw' is 0x47
	batt_curr_raw EQU 0x47
; 73: Dim batt_cur As Word
;       The address of 'batt_cur' is 0x49
	batt_cur EQU 0x49
; 74: Dim batt_curr_data(5) As Word
;       The address of 'batt_curr_data' is 0x4B
	batt_curr_data EQU 0x4B
; 75: Dim set_curr As Word
;       The address of 'set_curr' is 0x55
	set_curr EQU 0x55
; 76: 
; 77:  'SOLAR CELL MINIMUM  VALUES
; 78: Dim batt_min_volt As Word
;       The address of 'batt_min_volt' is 0x57
	batt_min_volt EQU 0x57
; 79: Dim solar_min_volt As Word
;       The address of 'solar_min_volt' is 0x59
	solar_min_volt EQU 0x59
; 80: 
; 81:  'POWER AND ENERGY CALCULATION
; 82: Dim power As Word
;       The address of 'power' is 0x5B
	power EQU 0x5B
; 83: Dim energy As Word
;       The address of 'energy' is 0x5D
	energy EQU 0x5D
; 84: Dim energy_aux As Word
;       The address of 'energy_aux' is 0x5F
	energy_aux EQU 0x5F
; 85: Dim power_act As Word
;       The address of 'power_act' is 0x61
	power_act EQU 0x61
; 86: 
; 87:  'FOR INTERRUPT
; 88: Dim int_count As Byte
;       The address of 'int_count' is 0x63
	int_count EQU 0x63
; 89: Dim en_count As Word
;       The address of 'en_count' is 0x64
	en_count EQU 0x64
; 90: 
; 91:  'MAIN LOGO AND DISPLAY INITIALISE
; 92: Lcdinit 0
	BCF 0x08,3
	BCF 0x08,1
	BCF 0x08,2
	BSF STATUS,RP0
	BCF 0x08,3
	BCF 0x08,1
	BCF 0x08,2
	CLRF 0x06
	BCF STATUS,RP0
	MOVLW 0x14
	MOVWF R0L
	MOVLW 0x00
	MOVWF R0H
	CALL W001
	MOVLW 0x33
	CALL LC02
	MOVLW 0x33
	CALL LC02
	MOVLW 0x33
	CALL LC02
	MOVLW 0x38
	CALL LC02
	MOVLW 0x0C
	CALL LC02
	MOVLW 0x01
	CALL LC02
; 93: WaitMs 10
	MOVLW 0x0A
	MOVWF R0L
	CLRF R0H
	CALL W001
; 94: Lcdcmdout LcdClear
	MOVLW 0x01
	CALL LC02
; 95: Lcdcmdout LcdLine1Home
	MOVLW 0x80
	CALL LC02
; 96: Lcdout "Solar Charge 1.0"
	MOVLW 0x53
	CALL LC01
	MOVLW 0x6F
	CALL LC01
	MOVLW 0x6C
	CALL LC01
	MOVLW 0x61
	CALL LC01
	MOVLW 0x72
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x43
	CALL LC01
	MOVLW 0x68
	CALL LC01
	MOVLW 0x61
	CALL LC01
	MOVLW 0x72
	CALL LC01
	MOVLW 0x67
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x31
	CALL LC01
	MOVLW 0x2E
	CALL LC01
	MOVLW 0x30
	CALL LC01
; 97: Lcdcmdout LcdLine2Home
	MOVLW 0xC0
	CALL LC02
; 98: Lcdout "SOLAR_CHARGE.hex"
	MOVLW 0x53
	CALL LC01
	MOVLW 0x4F
	CALL LC01
	MOVLW 0x4C
	CALL LC01
	MOVLW 0x41
	CALL LC01
	MOVLW 0x52
	CALL LC01
	MOVLW 0x5F
	CALL LC01
	MOVLW 0x43
	CALL LC01
	MOVLW 0x48
	CALL LC01
	MOVLW 0x41
	CALL LC01
	MOVLW 0x52
	CALL LC01
	MOVLW 0x47
	CALL LC01
	MOVLW 0x45
	CALL LC01
	MOVLW 0x2E
	CALL LC01
	MOVLW 0x68
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x78
	CALL LC01
; 99: WaitMs 2000
	MOVLW 0xD0
	MOVWF R0L
	MOVLW 0x07
	MOVWF R0H
	CALL W001
; 100:  ' FOR ENERGY CALCULATIONS
; 101: Dim en_unit As Byte
;       The address of 'en_unit' is 0x66
	en_unit EQU 0x66
; 102: Dim en_ten As Byte
;       The address of 'en_ten' is 0x67
	en_ten EQU 0x67
; 103: Dim en_hun As Byte
;       The address of 'en_hun' is 0x68
	en_hun EQU 0x68
; 104: Dim en_thou As Byte
;       The address of 'en_thou' is 0x69
	en_thou EQU 0x69
; 105: Dim en_total As Word
;       The address of 'en_total' is 0x6A
	en_total EQU 0x6A
; 106: Dim en_unitc As Byte
;       The address of 'en_unitc' is 0x6C
	en_unitc EQU 0x6C
; 107: Dim en_tenc As Byte
;       The address of 'en_tenc' is 0x6D
	en_tenc EQU 0x6D
; 108: Dim en_hunc As Byte
;       The address of 'en_hunc' is 0x6E
	en_hunc EQU 0x6E
; 109: Dim en_thouc As Byte
;       The address of 'en_thouc' is 0x6F
	en_thouc EQU 0x6F
; 110: Dim en_totalc As Word
;       The address of 'en_totalc' is 0x70
	en_totalc EQU 0x70
; 111: 
; 112:  'START THE MAIN PROGRAM
; 113: solar_min_volt = 12600
	MOVLW 0x38
	MOVWF 0x59
	MOVLW 0x31
	MOVWF 0x5A
; 114: batt_min_volt = 12100
	MOVLW 0x44
	MOVWF 0x57
	MOVLW 0x2F
	MOVWF 0x58
; 115: energy = 0
	CLRF 0x5D
	CLRF 0x5E
; 116: 
; 117:  'CLEAR SCREEN
; 118: Lcdcmdout LcdClear
	MOVLW 0x01
	CALL LC02
; 119: Lcdcmdout LcdHome
	MOVLW 0x02
	CALL LC02
; 120: Lcdcmdout LcdLine1Home
	MOVLW 0x80
	CALL LC02
; 121: 
; 122:  'START MAIN PROGRAM
; 123: start: 
L0001:
; 124: Disable
	BCF INTCON,GIE
; 125: Read 0, en_thou
	MOVLW 0x00
	BSF STATUS,RP1
	MOVWF EEADR
	BSF STATUS,RP0
	BCF EECON1,EEPGD
	BSF EECON1,RD
	NOP
	BCF STATUS,RP0
	MOVF EEDATA,W
	BCF STATUS,RP1
	MOVWF 0x69
; 126: Read 1, en_hun
	MOVLW 0x01
	BSF STATUS,RP1
	MOVWF EEADR
	BSF STATUS,RP0
	BCF EECON1,EEPGD
	BSF EECON1,RD
	NOP
	BCF STATUS,RP0
	MOVF EEDATA,W
	BCF STATUS,RP1
	MOVWF 0x68
; 127: Read 2, en_ten
	MOVLW 0x02
	BSF STATUS,RP1
	MOVWF EEADR
	BSF STATUS,RP0
	BCF EECON1,EEPGD
	BSF EECON1,RD
	NOP
	BCF STATUS,RP0
	MOVF EEDATA,W
	BCF STATUS,RP1
	MOVWF 0x67
; 128: Read 3, en_unit
	MOVLW 0x03
	BSF STATUS,RP1
	MOVWF EEADR
	BSF STATUS,RP0
	BCF EECON1,EEPGD
	BSF EECON1,RD
	NOP
	BCF STATUS,RP0
	MOVF EEDATA,W
	BCF STATUS,RP1
	MOVWF 0x66
; 129: Enable
	BSF INTCON,GIE
; 130: en_total = en_thou * 1000 + en_hun * 100 + en_ten * 10 + en_unit
	MOVF 0x69,W
	MOVWF R3L
	CLRF R3H
	MOVLW 0xE8
	MOVWF R1L
	MOVLW 0x03
	MOVWF R1H
	CALL M001
	MOVWF 0x6A
	MOVF R2H,W
	MOVWF 0x6B
;       The address of 'oshonsoft_temp_1' is 0x72
	oshonsoft_temp_1 EQU 0x72
	MOVF 0x68,W
	MOVWF R3L
	CLRF R3H
	MOVLW 0x64
	MOVWF R1L
	CLRF R1H
	CALL M001
	MOVWF 0x72
	MOVF R2H,W
	MOVWF 0x73
	MOVF 0x6A,W
	ADDWF 0x72,W
	MOVWF 0x6A
	MOVF 0x6B,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDWF 0x73,W
	MOVWF 0x6B
	MOVF 0x67,W
	MOVWF R3L
	CLRF R3H
	MOVLW 0x0A
	MOVWF R1L
	CLRF R1H
	CALL M001
	MOVWF 0x72
	MOVF R2H,W
	MOVWF 0x73
	MOVF 0x6A,W
	ADDWF 0x72,W
	MOVWF 0x6A
	MOVF 0x6B,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDWF 0x73,W
	MOVWF 0x6B
	MOVF 0x6A,W
	ADDWF 0x66,W
	MOVWF 0x6A
	MOVF 0x6B,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDLW 0x00
	MOVWF 0x6B
; 131: 
; 132: Gosub chk_solar_volt
	CALL L0002
; 133: Gosub chk_batt_volt
	CALL L0004
; 134: 
; 135: If solar_volt > solar_min_volt Then
	MOVF 0x45,W
	MOVWF R0L
	MOVF 0x46,W
	MOVWF R0H
	MOVF 0x5A,W
	MOVWF R1H
	MOVF 0x59,W
	CALL C003
	BTFSS STATUS,Z
	GOTO L0007
; 136: trickle_time_count = trickle_time_count + 1
	MOVF 0x3D,W
	ADDLW 0x01
	MOVWF 0x3D
	MOVF 0x3E,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDLW 0x00
	MOVWF 0x3E
; 137: If batt_volt < batt_min_volt Then
	MOVF 0x41,W
	MOVWF R0L
	MOVF 0x42,W
	MOVWF R0H
	MOVF 0x58,W
	MOVWF R1H
	MOVF 0x57,W
	CALL C004
	BTFSS STATUS,Z
	GOTO L0008
; 138: boost_on = 1
	BSF 0x39,0
; 139: trickle_on = 0
	BCF 0x39,1
; 140: Endif
L0008:	MOVLW 0x1F
	ANDWF STATUS,F
; 141: 
; 142: If batt_volt >= batt_min_volt Then
	MOVF 0x41,W
	MOVWF R0L
	MOVF 0x42,W
	MOVWF R0H
	MOVF 0x58,W
	MOVWF R1H
	MOVF 0x57,W
	CALL C005
	BTFSS STATUS,Z
	GOTO L0009
; 143: boost_on = 0
	BCF 0x39,0
; 144: trickle_on = 1
	BSF 0x39,1
; 145: Endif
L0009:	MOVLW 0x1F
	ANDWF STATUS,F
; 146: 
; 147: If boost_on = 1 Then
	BTFSS 0x39,0
	GOTO L0010
; 148: chg_on = 1
	BSF 0x05,3
; 149: Endif
L0010:	MOVLW 0x1F
	ANDWF STATUS,F
; 150: 
; 151: If trickle_on = 1 Then
	BTFSS 0x39,1
	GOTO L0011
; 152: If trickle_time_count <= 2 Then
	MOVF 0x3D,W
	MOVWF R0L
	MOVF 0x3E,W
	MOVWF R0H
	CLRF R1H
	MOVLW 0x02
	CALL C006
	BTFSS STATUS,Z
	GOTO L0012
; 153: chg_on = 1
	BSF 0x05,3
; 154: Endif
L0012:	MOVLW 0x1F
	ANDWF STATUS,F
; 155: 
; 156: If trickle_time_count > 2 Then
	MOVF 0x3D,W
	MOVWF R0L
	MOVF 0x3E,W
	MOVWF R0H
	CLRF R1H
	MOVLW 0x02
	CALL C003
	BTFSS STATUS,Z
	GOTO L0013
; 157: chg_on = 0
	BCF 0x05,3
; 158: Endif
L0013:	MOVLW 0x1F
	ANDWF STATUS,F
; 159: 
; 160: If trickle_time_count >= 4 Then
	MOVF 0x3D,W
	MOVWF R0L
	MOVF 0x3E,W
	MOVWF R0H
	CLRF R1H
	MOVLW 0x04
	CALL C005
	BTFSS STATUS,Z
	GOTO L0014
; 161: trickle_time_count = 0
	CLRF 0x3D
	CLRF 0x3E
; 162: Endif
L0014:	MOVLW 0x1F
	ANDWF STATUS,F
; 163: 
; 164: Endif
L0011:	MOVLW 0x1F
	ANDWF STATUS,F
; 165: WaitMs 1000
	MOVLW 0xE8
	MOVWF R0L
	MOVLW 0x03
	MOVWF R0H
	CALL W001
; 166: Gosub chk_batt_curr
	CALL L0003
; 167: Lcdcmdout LcdClear
	MOVLW 0x01
	CALL LC02
; 168: Lcdcmdout LcdHome
	MOVLW 0x02
	CALL LC02
; 169: Lcdcmdout LcdLine1Clear
	MOVLW 0x80
	CALL LC02
	MOVLW 0x10
	MOVWF R0L
L0015:	MOVLW 0x20
	CALL LC01
	DECFSZ R0L,F
	GOTO L0015
	MOVLW 0x80
	CALL LC02
; 170: Lcdcmdout LcdLine1Home
	MOVLW 0x80
	CALL LC02
; 171: Lcdout "B.Volts:", #batt_volt, " mV"
	MOVLW 0x42
	CALL LC01
	MOVLW 0x2E
	CALL LC01
	MOVLW 0x56
	CALL LC01
	MOVLW 0x6F
	CALL LC01
	MOVLW 0x6C
	CALL LC01
	MOVLW 0x74
	CALL LC01
	MOVLW 0x73
	CALL LC01
	MOVLW 0x3A
	CALL LC01
	MOVF 0x41,W
	MOVWF R2L
	MOVF 0x42,W
	MOVWF R2H
	CALL LC21
	MOVLW 0x20
	CALL LC01
	MOVLW 0x6D
	CALL LC01
	MOVLW 0x56
	CALL LC01
; 172: 
; 173: Lcdcmdout LcdLine2Clear
	MOVLW 0xC0
	CALL LC02
	MOVLW 0x10
	MOVWF R0L
L0016:	MOVLW 0x20
	CALL LC01
	DECFSZ R0L,F
	GOTO L0016
	MOVLW 0xC0
	CALL LC02
; 174: Lcdcmdout LcdLine2Home
	MOVLW 0xC0
	CALL LC02
; 175: Lcdout "C.Curr:", #batt_curr, " mA"
	MOVLW 0x43
	CALL LC01
	MOVLW 0x2E
	CALL LC01
	MOVLW 0x43
	CALL LC01
	MOVLW 0x75
	CALL LC01
	MOVLW 0x72
	CALL LC01
	MOVLW 0x72
	CALL LC01
	MOVLW 0x3A
	CALL LC01
	MOVF 0x3A,W
	MOVWF R2L
	MOVF 0x3B,W
	MOVWF R2H
	CALL LC21
	MOVLW 0x20
	CALL LC01
	MOVLW 0x6D
	CALL LC01
	MOVLW 0x41
	CALL LC01
; 176: 
; 177: WaitMs 2000
	MOVLW 0xD0
	MOVWF R0L
	MOVLW 0x07
	MOVWF R0H
	CALL W001
; 178: 
; 179: Lcdcmdout LcdLine1Clear
	MOVLW 0x80
	CALL LC02
	MOVLW 0x10
	MOVWF R0L
L0017:	MOVLW 0x20
	CALL LC01
	DECFSZ R0L,F
	GOTO L0017
	MOVLW 0x80
	CALL LC02
; 180: Lcdcmdout LcdLine1Home
	MOVLW 0x80
	CALL LC02
; 181: Lcdout "Energy(Wh)", #en_total,
	MOVLW 0x45
	CALL LC01
	MOVLW 0x6E
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x72
	CALL LC01
	MOVLW 0x67
	CALL LC01
	MOVLW 0x79
	CALL LC01
	MOVLW 0x28
	CALL LC01
	MOVLW 0x57
	CALL LC01
	MOVLW 0x68
	CALL LC01
	MOVLW 0x29
	CALL LC01
	MOVF 0x6A,W
	MOVWF R2L
	MOVF 0x6B,W
	MOVWF R2H
	CALL LC21
; 182: Lcdcmdout LcdLine2Clear
	MOVLW 0xC0
	CALL LC02
	MOVLW 0x10
	MOVWF R0L
L0018:	MOVLW 0x20
	CALL LC01
	DECFSZ R0L,F
	GOTO L0018
	MOVLW 0xC0
	CALL LC02
; 183: Lcdcmdout LcdLine2Home
	MOVLW 0xC0
	CALL LC02
; 184: Lcdout "Power: ", #power, " mW"
	MOVLW 0x50
	CALL LC01
	MOVLW 0x6F
	CALL LC01
	MOVLW 0x77
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x72
	CALL LC01
	MOVLW 0x3A
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVF 0x5B,W
	MOVWF R2L
	MOVF 0x5C,W
	MOVWF R2H
	CALL LC21
	MOVLW 0x20
	CALL LC01
	MOVLW 0x6D
	CALL LC01
	MOVLW 0x57
	CALL LC01
; 185: 
; 186: WaitMs 2000
	MOVLW 0xD0
	MOVWF R0L
	MOVLW 0x07
	MOVWF R0H
	CALL W001
; 187: 
; 188: Lcdcmdout LcdLine1Clear
	MOVLW 0x80
	CALL LC02
	MOVLW 0x10
	MOVWF R0L
L0019:	MOVLW 0x20
	CALL LC01
	DECFSZ R0L,F
	GOTO L0019
	MOVLW 0x80
	CALL LC02
; 189: Lcdcmdout LcdLine1Home
	MOVLW 0x80
	CALL LC02
; 190: Lcdout "Solar V:", #solar_volt, " mV"
	MOVLW 0x53
	CALL LC01
	MOVLW 0x6F
	CALL LC01
	MOVLW 0x6C
	CALL LC01
	MOVLW 0x61
	CALL LC01
	MOVLW 0x72
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x56
	CALL LC01
	MOVLW 0x3A
	CALL LC01
	MOVF 0x45,W
	MOVWF R2L
	MOVF 0x46,W
	MOVWF R2H
	CALL LC21
	MOVLW 0x20
	CALL LC01
	MOVLW 0x6D
	CALL LC01
	MOVLW 0x56
	CALL LC01
; 191: Lcdcmdout LcdLine2Clear
	MOVLW 0xC0
	CALL LC02
	MOVLW 0x10
	MOVWF R0L
L0020:	MOVLW 0x20
	CALL LC01
	DECFSZ R0L,F
	GOTO L0020
	MOVLW 0xC0
	CALL LC02
; 192: Lcdcmdout LcdLine2Home
	MOVLW 0xC0
	CALL LC02
; 193: Lcdout "B.Volt: ", #batt_volt, " mV"
	MOVLW 0x42
	CALL LC01
	MOVLW 0x2E
	CALL LC01
	MOVLW 0x56
	CALL LC01
	MOVLW 0x6F
	CALL LC01
	MOVLW 0x6C
	CALL LC01
	MOVLW 0x74
	CALL LC01
	MOVLW 0x3A
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVF 0x41,W
	MOVWF R2L
	MOVF 0x42,W
	MOVWF R2H
	CALL LC21
	MOVLW 0x20
	CALL LC01
	MOVLW 0x6D
	CALL LC01
	MOVLW 0x56
	CALL LC01
; 194: 
; 195: WaitMs 2000
	MOVLW 0xD0
	MOVWF R0L
	MOVLW 0x07
	MOVWF R0H
	CALL W001
; 196: 
; 197: Lcdcmdout LcdLine1Clear
	MOVLW 0x80
	CALL LC02
	MOVLW 0x10
	MOVWF R0L
L0021:	MOVLW 0x20
	CALL LC01
	DECFSZ R0L,F
	GOTO L0021
	MOVLW 0x80
	CALL LC02
; 198: Lcdcmdout LcdLine1Home
	MOVLW 0x80
	CALL LC02
; 199: If boost_on = 1 Then
	BTFSS 0x39,0
	GOTO L0022
; 200: Lcdout "Boost Chg: ON"
	MOVLW 0x42
	CALL LC01
	MOVLW 0x6F
	CALL LC01
	MOVLW 0x6F
	CALL LC01
	MOVLW 0x73
	CALL LC01
	MOVLW 0x74
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x43
	CALL LC01
	MOVLW 0x68
	CALL LC01
	MOVLW 0x67
	CALL LC01
	MOVLW 0x3A
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x4F
	CALL LC01
	MOVLW 0x4E
	CALL LC01
; 201: Else
	GOTO L0023
L0022:	MOVLW 0x1F
	ANDWF STATUS,F
; 202: Lcdout "Boost Chg: OFF"
	MOVLW 0x42
	CALL LC01
	MOVLW 0x6F
	CALL LC01
	MOVLW 0x6F
	CALL LC01
	MOVLW 0x73
	CALL LC01
	MOVLW 0x74
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x43
	CALL LC01
	MOVLW 0x68
	CALL LC01
	MOVLW 0x67
	CALL LC01
	MOVLW 0x3A
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x4F
	CALL LC01
	MOVLW 0x46
	CALL LC01
	MOVLW 0x46
	CALL LC01
; 203: Endif
L0023:	MOVLW 0x1F
	ANDWF STATUS,F
; 204: 
; 205: Lcdcmdout LcdLine2Clear
	MOVLW 0xC0
	CALL LC02
	MOVLW 0x10
	MOVWF R0L
L0024:	MOVLW 0x20
	CALL LC01
	DECFSZ R0L,F
	GOTO L0024
	MOVLW 0xC0
	CALL LC02
; 206: Lcdcmdout LcdLine2Home
	MOVLW 0xC0
	CALL LC02
; 207: 
; 208: If trickle_on = 1 Then
	BTFSS 0x39,1
	GOTO L0025
; 209: Lcdout "Trickle Chg: ON"
	MOVLW 0x54
	CALL LC01
	MOVLW 0x72
	CALL LC01
	MOVLW 0x69
	CALL LC01
	MOVLW 0x63
	CALL LC01
	MOVLW 0x6B
	CALL LC01
	MOVLW 0x6C
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x43
	CALL LC01
	MOVLW 0x68
	CALL LC01
	MOVLW 0x67
	CALL LC01
	MOVLW 0x3A
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x4F
	CALL LC01
	MOVLW 0x4E
	CALL LC01
; 210: Else
	GOTO L0026
L0025:	MOVLW 0x1F
	ANDWF STATUS,F
; 211: Lcdout "Trickle Chg: OFF"
	MOVLW 0x54
	CALL LC01
	MOVLW 0x72
	CALL LC01
	MOVLW 0x69
	CALL LC01
	MOVLW 0x63
	CALL LC01
	MOVLW 0x6B
	CALL LC01
	MOVLW 0x6C
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x43
	CALL LC01
	MOVLW 0x68
	CALL LC01
	MOVLW 0x67
	CALL LC01
	MOVLW 0x3A
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x4F
	CALL LC01
	MOVLW 0x46
	CALL LC01
	MOVLW 0x46
	CALL LC01
; 212: Endif
L0026:	MOVLW 0x1F
	ANDWF STATUS,F
; 213: 
; 214: WaitMs 1000
	MOVLW 0xE8
	MOVWF R0L
	MOVLW 0x03
	MOVWF R0H
	CALL W001
; 215: 
; 216: Else
	GOTO L0027
L0007:	MOVLW 0x1F
	ANDWF STATUS,F
; 217: Lcdcmdout LcdLine1Clear
	MOVLW 0x80
	CALL LC02
	MOVLW 0x10
	MOVWF R0L
L0028:	MOVLW 0x20
	CALL LC01
	DECFSZ R0L,F
	GOTO L0028
	MOVLW 0x80
	CALL LC02
; 218: Lcdcmdout LcdLine1Home
	MOVLW 0x80
	CALL LC02
; 219: Lcdout "Low Solar Volts"
	MOVLW 0x4C
	CALL LC01
	MOVLW 0x6F
	CALL LC01
	MOVLW 0x77
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x53
	CALL LC01
	MOVLW 0x6F
	CALL LC01
	MOVLW 0x6C
	CALL LC01
	MOVLW 0x61
	CALL LC01
	MOVLW 0x72
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x56
	CALL LC01
	MOVLW 0x6F
	CALL LC01
	MOVLW 0x6C
	CALL LC01
	MOVLW 0x74
	CALL LC01
	MOVLW 0x73
	CALL LC01
; 220: Lcdcmdout LcdLine2Clear
	MOVLW 0xC0
	CALL LC02
	MOVLW 0x10
	MOVWF R0L
L0029:	MOVLW 0x20
	CALL LC01
	DECFSZ R0L,F
	GOTO L0029
	MOVLW 0xC0
	CALL LC02
; 221: Lcdcmdout LcdLine2Home
	MOVLW 0xC0
	CALL LC02
; 222: Lcdout "Waiting..",
	MOVLW 0x57
	CALL LC01
	MOVLW 0x61
	CALL LC01
	MOVLW 0x69
	CALL LC01
	MOVLW 0x74
	CALL LC01
	MOVLW 0x69
	CALL LC01
	MOVLW 0x6E
	CALL LC01
	MOVLW 0x67
	CALL LC01
	MOVLW 0x2E
	CALL LC01
	MOVLW 0x2E
	CALL LC01
; 223: 
; 224: WaitMs 2000
	MOVLW 0xD0
	MOVWF R0L
	MOVLW 0x07
	MOVWF R0H
	CALL W001
; 225: Lcdcmdout LcdLine2Clear
	MOVLW 0xC0
	CALL LC02
	MOVLW 0x10
	MOVWF R0L
L0030:	MOVLW 0x20
	CALL LC01
	DECFSZ R0L,F
	GOTO L0030
	MOVLW 0xC0
	CALL LC02
; 226: Lcdcmdout LcdLine2Home
	MOVLW 0xC0
	CALL LC02
; 227: Lcdout "B.Volt: ", #batt_volt, " mV"
	MOVLW 0x42
	CALL LC01
	MOVLW 0x2E
	CALL LC01
	MOVLW 0x56
	CALL LC01
	MOVLW 0x6F
	CALL LC01
	MOVLW 0x6C
	CALL LC01
	MOVLW 0x74
	CALL LC01
	MOVLW 0x3A
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVF 0x41,W
	MOVWF R2L
	MOVF 0x42,W
	MOVWF R2H
	CALL LC21
	MOVLW 0x20
	CALL LC01
	MOVLW 0x6D
	CALL LC01
	MOVLW 0x56
	CALL LC01
; 228: 
; 229: WaitMs 2000
	MOVLW 0xD0
	MOVWF R0L
	MOVLW 0x07
	MOVWF R0H
	CALL W001
; 230: Lcdcmdout LcdLine2Clear
	MOVLW 0xC0
	CALL LC02
	MOVLW 0x10
	MOVWF R0L
L0031:	MOVLW 0x20
	CALL LC01
	DECFSZ R0L,F
	GOTO L0031
	MOVLW 0xC0
	CALL LC02
; 231: Lcdcmdout LcdLine2Home
	MOVLW 0xC0
	CALL LC02
; 232: Lcdout "Solar V:", #solar_volt, " mV"
	MOVLW 0x53
	CALL LC01
	MOVLW 0x6F
	CALL LC01
	MOVLW 0x6C
	CALL LC01
	MOVLW 0x61
	CALL LC01
	MOVLW 0x72
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVLW 0x56
	CALL LC01
	MOVLW 0x3A
	CALL LC01
	MOVF 0x45,W
	MOVWF R2L
	MOVF 0x46,W
	MOVWF R2H
	CALL LC21
	MOVLW 0x20
	CALL LC01
	MOVLW 0x6D
	CALL LC01
	MOVLW 0x56
	CALL LC01
; 233: WaitMs 2000
	MOVLW 0xD0
	MOVWF R0L
	MOVLW 0x07
	MOVWF R0H
	CALL W001
; 234: 
; 235: Endif
L0027:	MOVLW 0x1F
	ANDWF STATUS,F
; 236: Goto start
	GOTO L0001
; 237: 
; 238: End
L0032:	GOTO L0032
; 239:  'CHECK SOLAR CELL VOLTAGE
; 240:  'return batt_volt in mV
; 241: chk_solar_volt: 
L0002:
; 242: If boost_on = 1 Then
	BTFSS 0x39,0
	GOTO L0033
; 243: was_boost = 1
	BSF 0x39,2
; 244: Else
	GOTO L0034
L0033:	MOVLW 0x1F
	ANDWF STATUS,F
; 245: was_boost = 0
	BCF 0x39,2
; 246: Endif
L0034:	MOVLW 0x1F
	ANDWF STATUS,F
; 247: 
; 248: If trickle_on = 1 Then
	BTFSS 0x39,1
	GOTO L0035
; 249: was_trickle = 1
	BSF 0x39,3
; 250: Else
	GOTO L0036
L0035:	MOVLW 0x1F
	ANDWF STATUS,F
; 251: was_trickle = 0
	BCF 0x39,3
; 252: Endif
L0036:	MOVLW 0x1F
	ANDWF STATUS,F
; 253: chg_on = 0
	BCF 0x05,3
; 254: 
; 255: WaitMs 50
	MOVLW 0x32
	MOVWF R0L
	CLRF R0H
	CALL W001
; 256: Adcin 2, solar_volt_raw
	BSF STATUS,RP0
	BSF ADCON1,ADFM
	BCF ADCON1,ADCS2
	MOVLW 0x02
	BCF STATUS,RP0
	MOVWF R0L
	CALL A001
	BSF STATUS,RP0
	MOVF ADRESL,W
	BCF STATUS,RP0
	MOVWF 0x43
	MOVF ADRESH,W
	MOVWF 0x44
; 257: solar_volt = solar_volt_raw * 20
	MOVF 0x43,W
	MOVWF R3L
	MOVF 0x44,W
	MOVWF R3H
	MOVLW 0x14
	MOVWF R1L
	CLRF R1H
	CALL M001
	MOVWF 0x45
	MOVF R2H,W
	MOVWF 0x46
; 258: 
; 259: If was_boost = 1 Then
	BTFSS 0x39,2
	GOTO L0037
; 260: boost_on = 1
	BSF 0x39,0
; 261: Else
	GOTO L0038
L0037:	MOVLW 0x1F
	ANDWF STATUS,F
; 262: boost_on = 0
	BCF 0x39,0
; 263: Endif
L0038:	MOVLW 0x1F
	ANDWF STATUS,F
; 264: 
; 265: If was_trickle = 1 Then
	BTFSS 0x39,3
	GOTO L0039
; 266: trickle_on = 1
	BSF 0x39,1
; 267: Else
	GOTO L0040
L0039:	MOVLW 0x1F
	ANDWF STATUS,F
; 268: trickle_on = 0
	BCF 0x39,1
; 269: Endif
L0040:	MOVLW 0x1F
	ANDWF STATUS,F
; 270: was_boost = 0
	BCF 0x39,2
; 271: was_trickle = 0
	BCF 0x39,3
; 272: 
; 273: Return
	RETURN
; 274:  'CHECK BATTERY CURRENT
; 275:  'return batt_curr in ma
; 276: chk_batt_curr: 
L0003:
; 277: For batt_curr_count = 0 To 4
	CLRF 0x3C
L0041:
	MOVF 0x3C,W
	SUBLW 0x04
	BTFSS STATUS,C
	GOTO L0042
; 278: Adcin 1, batt_curr_data(batt_curr_count)
	BSF STATUS,RP0
	BSF ADCON1,ADFM
	BCF ADCON1,ADCS2
	MOVLW 0x01
	BCF STATUS,RP0
	MOVWF R0L
	CALL A001
	BSF STATUS,RP0
	MOVF ADRESL,W
	BCF STATUS,RP0
	MOVWF R5L
	BCF STATUS,C
	RLF 0x3C,W
	ADDLW 0x4B
	MOVWF FSR
	MOVF R5L,W
	MOVWF INDF
	MOVF ADRESH,W
	INCF FSR,F
	MOVWF INDF
; 279: WaitMs 10
	MOVLW 0x0A
	MOVWF R0L
	CLRF R0H
	CALL W001
; 280: Next batt_curr_count
	MOVLW 0x01
	ADDWF 0x3C,F
	BTFSS STATUS,C
	GOTO L0041
L0042:	MOVLW 0x1F
	ANDWF STATUS,F
; 281: batt_curr_raw = (batt_curr_data(0) + batt_curr_data(1) + batt_curr_data(2) + batt_curr_data(3) + batt_curr_data(4)) / 5
	MOVF 0x4B,W
	ADDWF 0x4D,W
	MOVWF 0x47
	MOVF 0x4C,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDWF 0x4E,W
	MOVWF 0x48
	MOVF 0x47,W
	ADDWF 0x4F,W
	MOVWF 0x47
	MOVF 0x48,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDWF 0x50,W
	MOVWF 0x48
	MOVF 0x47,W
	ADDWF 0x51,W
	MOVWF 0x47
	MOVF 0x48,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDWF 0x52,W
	MOVWF 0x48
	MOVF 0x47,W
	ADDWF 0x53,W
	MOVWF 0x47
	MOVF 0x48,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDWF 0x54,W
	MOVWF 0x48
	MOVF 0x47,W
	MOVWF R0L
	MOVF 0x48,W
	MOVWF R0H
	MOVLW 0x05
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVWF 0x47
	MOVF R0H,W
	MOVWF 0x48
; 282: batt_curr = batt_curr_raw
	MOVF 0x47,W
	MOVWF 0x3A
	MOVF 0x48,W
	MOVWF 0x3B
; 283: Return
	RETURN
; 284:  'CHECK BATTERY VOLTAGE
; 285:  'return batt_volt in mV
; 286: chk_batt_volt: 
L0004:
; 287: If boost_on = 1 Then
	BTFSS 0x39,0
	GOTO L0043
; 288: was_boost = 1
	BSF 0x39,2
; 289: 
; 290: Else
	GOTO L0044
L0043:	MOVLW 0x1F
	ANDWF STATUS,F
; 291: was_boost = 0
	BCF 0x39,2
; 292: Endif
L0044:	MOVLW 0x1F
	ANDWF STATUS,F
; 293: 
; 294: If trickle_on = 1 Then
	BTFSS 0x39,1
	GOTO L0045
; 295: was_trickle = 1
	BSF 0x39,3
; 296: Else
	GOTO L0046
L0045:	MOVLW 0x1F
	ANDWF STATUS,F
; 297: was_trickle = 0
	BCF 0x39,3
; 298: Endif
L0046:	MOVLW 0x1F
	ANDWF STATUS,F
; 299: 
; 300: chg_on = 0
	BCF 0x05,3
; 301: WaitMs 50
	MOVLW 0x32
	MOVWF R0L
	CLRF R0H
	CALL W001
; 302: Adcin 0, batt_volt_raw
	BSF STATUS,RP0
	BSF ADCON1,ADFM
	BCF ADCON1,ADCS2
	MOVLW 0x00
	BCF STATUS,RP0
	MOVWF R0L
	CALL A001
	BSF STATUS,RP0
	MOVF ADRESL,W
	BCF STATUS,RP0
	MOVWF 0x3F
	MOVF ADRESH,W
	MOVWF 0x40
; 303: batt_volt = batt_volt_raw * 20
	MOVF 0x3F,W
	MOVWF R3L
	MOVF 0x40,W
	MOVWF R3H
	MOVLW 0x14
	MOVWF R1L
	CLRF R1H
	CALL M001
	MOVWF 0x41
	MOVF R2H,W
	MOVWF 0x42
; 304: 
; 305: If was_boost = 1 Then
	BTFSS 0x39,2
	GOTO L0047
; 306: boost_on = 1
	BSF 0x39,0
; 307: Else
	GOTO L0048
L0047:	MOVLW 0x1F
	ANDWF STATUS,F
; 308: boost_on = 0
	BCF 0x39,0
; 309: Endif
L0048:	MOVLW 0x1F
	ANDWF STATUS,F
; 310: 
; 311: If was_trickle = 1 Then
	BTFSS 0x39,3
	GOTO L0049
; 312: trickle_on = 1
	BSF 0x39,1
; 313: Else
	GOTO L0050
L0049:	MOVLW 0x1F
	ANDWF STATUS,F
; 314: trickle_on = 0
	BCF 0x39,1
; 315: Endif
L0050:	MOVLW 0x1F
	ANDWF STATUS,F
; 316: was_boost = 0
	BCF 0x39,2
; 317: was_trickle = 0
	BCF 0x39,3
; 318: 
; 319: Return
	RETURN
; 320: 
; 321: On Interrupt
L0006:
; 322: Save System
	MOVF R0L,W
	MOVWF R0L_TEMP
	MOVF R0H,W
	MOVWF R0H_TEMP
	MOVF R1L,W
	MOVWF R1L_TEMP
	MOVF R1H,W
	MOVWF R1H_TEMP
	MOVF R2L,W
	MOVWF R2L_TEMP
	MOVF R2H,W
	MOVWF R2H_TEMP
	MOVF R3L,W
	MOVWF R3L_TEMP
	MOVF R3H,W
	MOVWF R3H_TEMP
	MOVF R4L,W
	MOVWF R4L_TEMP
	MOVF R4H,W
	MOVWF R4H_TEMP
	MOVF R5L,W
	MOVWF R5L_TEMP
	MOVF R5H,W
	MOVWF R5H_TEMP
	MOVF FSR,W
	MOVWF FSR_TEMP
; 323: en_count = en_count + 1
	MOVF 0x64,W
	ADDLW 0x01
	MOVWF 0x64
	MOVF 0x65,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDLW 0x00
	MOVWF 0x65
; 324: int_count = int_count + 1
	MOVF 0x63,W
	ADDLW 0x01
	MOVWF 0x63
; 325: 
; 326:  '1 SEC INTERRUPT
; 327: If int_count = 15 Then
	MOVF 0x63,W
	SUBLW 0x0F
	BTFSS STATUS,Z
	GOTO L0051
; 328: int_count = 0
	CLRF 0x63
; 329: power = (batt_volt / 1000) * (batt_curr)
	MOVF 0x41,W
	MOVWF R0L
	MOVF 0x42,W
	MOVWF R0H
	MOVLW 0xE8
	MOVWF R1L
	MOVLW 0x03
	MOVWF R1H
	CALL D001
	MOVWF 0x5B
	MOVF R0H,W
	MOVWF 0x5C
	MOVF 0x5B,W
	MOVWF R3L
	MOVF 0x5C,W
	MOVWF R3H
	MOVF 0x3A,W
	MOVWF R1L
	MOVF 0x3B,W
	MOVWF R1H
	CALL M001
	MOVWF 0x5B
	MOVF R2H,W
	MOVWF 0x5C
; 330: energy_aux = energy_aux + power
	MOVF 0x5F,W
	ADDWF 0x5B,W
	MOVWF 0x5F
	MOVF 0x60,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDWF 0x5C,W
	MOVWF 0x60
; 331: 
; 332:  'ENERGY IN WS
; 333: If energy_aux >= 1000 Then
	MOVF 0x5F,W
	MOVWF R0L
	MOVF 0x60,W
	MOVWF R0H
	MOVLW 0x03
	MOVWF R1H
	MOVLW 0xE8
	CALL C005
	BTFSS STATUS,Z
	GOTO L0052
; 334: energy = energy + 1
	MOVF 0x5D,W
	ADDLW 0x01
	MOVWF 0x5D
	MOVF 0x5E,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDLW 0x00
	MOVWF 0x5E
; 335: energy_aux = 0
	CLRF 0x5F
	CLRF 0x60
; 336: Endif
L0052:	MOVLW 0x1F
	ANDWF STATUS,F
; 337: 
; 338:  'ENERGY IN WH
; 339: If energy >= 3600 Then
	MOVF 0x5D,W
	MOVWF R0L
	MOVF 0x5E,W
	MOVWF R0H
	MOVLW 0x0E
	MOVWF R1H
	MOVLW 0x10
	CALL C005
	BTFSS STATUS,Z
	GOTO L0053
; 340: en_totalc = en_totalc + 1
	MOVF 0x70,W
	ADDLW 0x01
	MOVWF 0x70
	MOVF 0x71,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDLW 0x00
	MOVWF 0x71
; 341: energy = 0
	CLRF 0x5D
	CLRF 0x5E
; 342: Endif
L0053:	MOVLW 0x1F
	ANDWF STATUS,F
; 343: 
; 344: If en_totalc >= 9999 Then
	MOVF 0x70,W
	MOVWF R0L
	MOVF 0x71,W
	MOVWF R0H
	MOVLW 0x27
	MOVWF R1H
	MOVLW 0x0F
	CALL C005
	BTFSS STATUS,Z
	GOTO L0054
; 345: en_totalc = 0
	CLRF 0x70
	CLRF 0x71
; 346: Endif
L0054:	MOVLW 0x1F
	ANDWF STATUS,F
; 347: 
; 348: Endif
L0051:	MOVLW 0x1F
	ANDWF STATUS,F
; 349: 
; 350:  '1/2 HR INTERRUPT
; 351: If en_count = 27000 Then
	MOVF 0x64,W
	MOVWF R0L
	MOVF 0x65,W
	MOVWF R0H
	MOVLW 0x69
	MOVWF R1H
	MOVLW 0x78
	CALL C001
	BTFSS STATUS,Z
	GOTO L0055
; 352: en_count = 0
	CLRF 0x64
	CLRF 0x65
; 353: en_unitc = en_totalc Mod 10
	MOVF 0x70,W
	MOVWF R0L
	MOVF 0x71,W
	MOVWF R0H
	MOVLW 0x0A
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVF R2L,W
	MOVWF 0x6C
; 354: en_tenc = (en_totalc / 10) Mod 10
	MOVF 0x70,W
	MOVWF R0L
	MOVF 0x71,W
	MOVWF R0H
	MOVLW 0x0A
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVWF 0x5B
	MOVF R0H,W
	MOVWF 0x5C
	MOVF 0x5B,W
	MOVWF R0L
	MOVF 0x5C,W
	MOVWF R0H
	MOVLW 0x0A
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVF R2L,W
	MOVWF 0x5B
	MOVF R2H,W
	MOVWF 0x5C
	MOVF 0x5B,W
	MOVWF 0x6D
; 355: en_hunc = (en_totalc / 100) Mod 10
	MOVF 0x70,W
	MOVWF R0L
	MOVF 0x71,W
	MOVWF R0H
	MOVLW 0x64
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVWF 0x5B
	MOVF R0H,W
	MOVWF 0x5C
	MOVF 0x5B,W
	MOVWF R0L
	MOVF 0x5C,W
	MOVWF R0H
	MOVLW 0x0A
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVF R2L,W
	MOVWF 0x5B
	MOVF R2H,W
	MOVWF 0x5C
	MOVF 0x5B,W
	MOVWF 0x6E
; 356: en_thouc = en_totalc / 1000
	MOVF 0x70,W
	MOVWF R0L
	MOVF 0x71,W
	MOVWF R0H
	MOVLW 0xE8
	MOVWF R1L
	MOVLW 0x03
	MOVWF R1H
	CALL D001
	MOVWF 0x6F
; 357: Write 0, en_thouc
	MOVLW 0x00
	BSF STATUS,RP1
	MOVWF EEADR
	BCF STATUS,RP1
	MOVF 0x6F,W
	BSF STATUS,RP1
	MOVWF EEDATA
	BSF STATUS,RP0
	BCF EECON1,EEPGD
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0056:	BTFSC EECON1,WR
	GOTO L0056
	BCF EECON1,WREN
	BCF STATUS,RP1
	BCF STATUS,RP0
	BCF PIR2,EEIF
; 358: Write 1, en_hunc
	MOVLW 0x01
	BSF STATUS,RP1
	MOVWF EEADR
	BCF STATUS,RP1
	MOVF 0x6E,W
	BSF STATUS,RP1
	MOVWF EEDATA
	BSF STATUS,RP0
	BCF EECON1,EEPGD
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0057:	BTFSC EECON1,WR
	GOTO L0057
	BCF EECON1,WREN
	BCF STATUS,RP1
	BCF STATUS,RP0
	BCF PIR2,EEIF
; 359: Write 2, en_tenc
	MOVLW 0x02
	BSF STATUS,RP1
	MOVWF EEADR
	BCF STATUS,RP1
	MOVF 0x6D,W
	BSF STATUS,RP1
	MOVWF EEDATA
	BSF STATUS,RP0
	BCF EECON1,EEPGD
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0058:	BTFSC EECON1,WR
	GOTO L0058
	BCF EECON1,WREN
	BCF STATUS,RP1
	BCF STATUS,RP0
	BCF PIR2,EEIF
; 360: Write 3, en_unitc
	MOVLW 0x03
	BSF STATUS,RP1
	MOVWF EEADR
	BCF STATUS,RP1
	MOVF 0x6C,W
	BSF STATUS,RP1
	MOVWF EEDATA
	BSF STATUS,RP0
	BCF EECON1,EEPGD
	BSF EECON1,WREN
	MOVLW 0x55
	MOVWF EECON2
	MOVLW 0xAA
	MOVWF EECON2
	BSF EECON1,WR
L0059:	BTFSC EECON1,WR
	GOTO L0059
	BCF EECON1,WREN
	BCF STATUS,RP1
	BCF STATUS,RP0
	BCF PIR2,EEIF
; 361: Endif
L0055:	MOVLW 0x1F
	ANDWF STATUS,F
; 362: 
; 363: INTCON.T0IF = 0
	BCF 0x0B,2
; 364: Resume
	MOVF R0L_TEMP,W
	MOVWF R0L
	MOVF R0H_TEMP,W
	MOVWF R0H
	MOVF R1L_TEMP,W
	MOVWF R1L
	MOVF R1H_TEMP,W
	MOVWF R1H
	MOVF R2L_TEMP,W
	MOVWF R2L
	MOVF R2H_TEMP,W
	MOVWF R2H
	MOVF R3L_TEMP,W
	MOVWF R3L
	MOVF R3H_TEMP,W
	MOVWF R3H
	MOVF R4L_TEMP,W
	MOVWF R4L
	MOVF R4H_TEMP,W
	MOVWF R4H
	MOVF R5L_TEMP,W
	MOVWF R5L
	MOVF R5H_TEMP,W
	MOVWF R5H
	MOVF FSR_TEMP,W
	MOVWF FSR
	RETURN
; End of program
L0060:	GOTO L0060
; Multiplication Routine
M001:	MOVLW 0x10
	MOVWF R4L
	CLRF R0H
	CLRF R0L
M002:	RRF R3H,F
	RRF R3L,F
	BTFSS STATUS,C
	GOTO M003
	MOVF R1L,W
	ADDWF R0L,F
	MOVF R1H,W
	BTFSC STATUS,C
	INCFSZ R1H,W
	ADDWF R0H,F
M003:	RRF R0H,F
	RRF R0L,F
	RRF R2H,F
	RRF R2L,F
	DECFSZ R4L,F
	GOTO M002
	MOVF R2L,W
	RETURN
; Division Routine
D001:	MOVLW 0x10
	MOVWF R3L
	CLRF R2H
	CLRF R2L
D002:	RLF R0H,W
	RLF R2L,F
	RLF R2H,F
	MOVF R1L,W
	SUBWF R2L,F
	MOVF R1H,W
	BTFSS STATUS,C
	INCFSZ R1H,W
	SUBWF R2H,F
	BTFSC STATUS,C
	GOTO D003
	MOVF R1L,W
	ADDWF R2L,F
	MOVF R1H,W
	BTFSC STATUS,C
	INCFSZ R1H,W
	ADDWF R2H,F
	BCF STATUS,C
D003:	RLF R0L,F
	RLF R0H,F
	DECFSZ R3L,F
	GOTO D002
	MOVF R0L,W
	RETURN
; Comparison Routine
C001:	MOVWF R1L
	MOVLW 0x05
	GOTO C007
C002:	MOVWF R1L
	MOVLW 0x02
	GOTO C007
C003:	MOVWF R1L
	MOVLW 0x06
	GOTO C007
C004:	MOVWF R1L
	MOVLW 0x03
	GOTO C007
C005:	MOVWF R1L
	MOVLW 0x04
	GOTO C007
C006:	MOVWF R1L
	MOVLW 0x01
	GOTO C007
C007:	MOVWF R4L
	MOVF R1H,W
	SUBWF R0H,W
	BTFSS STATUS,Z
	GOTO C008
	MOVF R1L,W
	SUBWF R0L,W
C008:	MOVLW 0x04
	BTFSC STATUS,C
	MOVLW 0x01
	BTFSC STATUS,Z
	MOVLW 0x02
	ANDWF R4L,W
	BTFSS STATUS,Z
	MOVLW 0xFF
	RETURN
; Waitms Routine
W001:	MOVF R0L,F
	BTFSC STATUS,Z
	GOTO W002
	CALL W003
	DECF R0L,F
	NOP
	NOP
	NOP
	NOP
	NOP
	GOTO W001
W002:	MOVF R0H,F
	BTFSC STATUS,Z
	RETURN
	CALL W003
	DECF R0H,F
	DECF R0L,F
	GOTO W001
W003:	MOVLW 0x0C
	MOVWF R2H
W004:	DECFSZ R2H,F
	GOTO W004
	NOP
	NOP
	MOVLW 0x12
	MOVWF R1L
W005:	DECFSZ R1L,F
	GOTO W006
	CALL W007
	CALL W007
	NOP
	NOP
	RETURN
W006:	CALL W007
	GOTO W005
W007:	MOVLW 0x0D
	MOVWF R2L
W008:	DECFSZ R2L,F
	GOTO W008
	NOP
	RETURN
; Waitus Routine - Byte Argument
X001:	MOVLW 0x0A
	SUBWF R4L,F
	BTFSS STATUS,C
	RETURN
	GOTO X002
X002:	MOVLW 0x06
	SUBWF R4L,F
	BTFSS STATUS,C
	RETURN
	GOTO X002
; Waitus Routine - Word Argument
Y001:	MOVLW 0x10
	SUBWF R4L,F
	CLRW
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF R4H,F
	BTFSS STATUS,C
	RETURN
	GOTO Y002
Y002:	MOVLW 0x0A
	SUBWF R4L,F
	CLRW
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF R4H,F
	BTFSS STATUS,C
	RETURN
	GOTO Y002
; Adcin Routine
A001:	RLF R0L,F
	RLF R0L,F
	RLF R0L,F
	MOVLW 0x38
	ANDWF R0L,F
	MOVLW 0xC1
	IORWF R0L,W
	MOVWF ADCON0
	MOVLW 0x64
	MOVWF R4L
	CALL X001
	BSF ADCON0,GO
A002:	BTFSC ADCON0,GO
	GOTO A002
	BCF PIR1,ADIF
	BCF ADCON0,ADON
	RETURN
; Lcdout Routine
LC01:	BSF 0x08,1
	BCF 0x08,2
	MOVWF 0x06
	BSF 0x08,3
	NOP
	BCF 0x08,3
	MOVLW 0x64
	MOVWF R4L
	CALL X001
	RETURN
; Lcdcmdout Routine
LC02:	BCF 0x08,1
	BCF 0x08,2
	MOVWF 0x06
	BSF 0x08,3
	NOP
	BCF 0x08,3
	MOVLW 0x88
	MOVWF R4L
	MOVLW 0x13
	MOVWF R4H
	CALL Y001
	RETURN
; Lcdout Decimal Conversion Routine
LC21:	BSF R3H,7
	MOVLW 0x27
	MOVWF R1H
	MOVLW 0x10
	CALL LC22
	MOVLW 0x03
	MOVWF R1H
	MOVLW 0xE8
	CALL LC22
	CLRF R1H
	MOVLW 0x64
	CALL LC22
	CLRF R1H
	MOVLW 0x0A
	CALL LC22
	MOVF R2L,W
	GOTO LC23
LC22:	MOVWF R1L
	MOVF R2H,W
	MOVWF R0H
	MOVF R2L,W
	MOVWF R0L
	CALL D001
	MOVF R0L,W
	BTFSS STATUS,Z
	BCF R3H,7
	BTFSC R3H,7
	RETURN
LC23:	ADDLW 0x30
	CALL LC01
	RETURN
; End of listing
	END
